<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ page import="java.util.*"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.view.MobileGatewayUser"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.MobileGatewaySession"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.ExternalServiceResponse"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.ExternalServiceResponseCode"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.ExternalServiceRequest"%>
<%@ page import="com.invoqsystems.apex.exceptions.AlarmPointDatabaseException"%>
<%@ page import="com.invoqsystems.apex.exceptions.AlarmPointNetworkException"%>
<%@ page import="com.invoqsystems.apex.web.exceptions.AlarmPointTimeOutException"%>
<%@ page import="com.alarmpoint.integration.*"%>
<%@ page import="org.dom4j.Node" %>
<%@ page import="com.alarmpoint.integrations.nnmi.mg.*"%>
<%@ page import="com.hp.ov.nms.sdk.incident.*"%>
<%@ page import="com.hp.ov.nms.sdk.incident.IncidentBeanServiceStub.*"%>
<%@ page import="com.hp.ov.nms.sdk.node.NodeBeanServiceStub.*"%>
<%@ page import="com.hp.ov.nms.sdk.iface.InterfaceBeanServiceStub.*"%>
<%@ page import="com.hp.ov.nms.sdk.ipaddress.IPAddressBeanServiceStub.*"%>
<%@ page import="com.hp.ov.nms.sdk.ipsubnet.IPSubnetBeanServiceStub.*"%>
<%@ page import="com.hp.ov.nms.sdk.l2connection.L2ConnectionBeanServiceStub.*"%>

<jsp:useBean class="com.alarmpoint.apex.mobilegateway.util.MobileGatewaySession" id="mobileGatewaySession" scope="session" />
<%
String action = request.getParameter( "action" );
Incident event = (Incident)session.getAttribute( "event" );

if( "Go".equalsIgnoreCase( action ) )
//We are trying to navigate to another page
{
%>
  <jsp:forward page="<%=response.encodeURL(request.getParameter("menuURL"))%>"/>
<%
}

else if ( "Update Notes".equalsIgnoreCase( action ) )
{
  ExternalServiceRequest esr = mobileGatewaySession.createExternalServiceRequest();
  ExternalServiceResponse resps;
  esr.setAction("addAnnotation");
  esr.addToken("Incident_ID", event.getId());
  esr.addToken("Annotation_Text", (String)request.getParameter("Notes"));
  %>
  <%@ include file="includes/sendRequest.jsp"%>
  <%

  String status = "&message=Annotation Added";
  %>
  <jsp:forward page="<%=response.encodeURL("loadEvent.jsp?tab=Annotations&Incident_ID="+event.getId()+status)%>"/>
  <%

}

else if ( "Save".equalsIgnoreCase( action ) )
{
  String priority = null;
  String lifecycleState = null;
  String assignedTo = null;

  Incident orgEvent = (Incident)session.getAttribute( "orgEvent" );

  // check to see if the orgEvent has had its priority updated
  if (!orgEvent.getPriority().equals(request.getParameter("Priority"))) {
    priority = request.getParameter("Priority");
  }
  // check to see if the orgEvent has had its lifecycleState updated
  if (!orgEvent.getLifecycleState().equals(request.getParameter("Lifecycle State"))) {
    lifecycleState = request.getParameter("Lifecycle State");
  }
  // check to see if the orgEvent has had its assignedTo updated
  if (!orgEvent.getAssignedTo().equals(request.getParameter("Assigned To"))) {
    assignedTo = request.getParameter("Assigned To");
  }

  if (priority != null || lifecycleState != null || assignedTo != null) {
    ExternalServiceRequest esr = mobileGatewaySession.createExternalServiceRequest();
    ExternalServiceResponse resps;
    esr.setAction("saveIncident");
    esr.addToken("Incident_ID", (String)event.getId());
    esr.addToken("Priority", priority);
    esr.addToken("LifecycleState", lifecycleState);
    esr.addToken("AssignedTo", assignedTo);
    %>
    <%@ include file="includes/sendRequest.jsp"%>
    <%

      String status = "&message=Saved";
      %>
      <jsp:forward page="<%=response.encodeURL("loadEvent.jsp?tab=Basics&Incident_ID="+event.getId()+status)%>"/>
      <%
  }
  else {
    %>
      <jsp:forward page="<%=response.encodeURL("loadEvent.jsp?tab=Basics&Incident_ID="+event.getId())%>"/>
      <%
  }
}

// We need to see if we are dealing with a Field Search Page
else
{
  // Check to see if there is a field search being preformed
  Enumeration<String> parameterNames = request.getParameterNames();
  while ( parameterNames.hasMoreElements() )
  {
    String field = parameterNames.nextElement();
    String pageURL = request.getParameter("pageURL");
    String tab = request.getParameter("tab");

    if ( field.startsWith( "search" ) ) {
      // forward the page to the field search which will call the appropriate associated jsp
      String searchUrl = "fieldSearch.jsp?url="+pageURL+"&tab="+tab+"&jsp="+field;
      %>
        <jsp:forward page="<%=response.encodeURL(searchUrl)%>"/>
      <%
    }
  }
}
%>
