<%
if ( FieldType.READONLY.equals(type) )
{
    out.print( value );
}

else if ( FieldType.TEXT.equals(type) )
{
  %>
  <input type="text" name="<%=label%>" value="<%=value%>"/>
  <%
}

else if ( FieldType.TEXTAREA.equals(type) )
{
  %>
  <textarea style="font-family: Verdana, Geneva, Arial, Helvetica, sans-serif;font-size: .8em;"
    name="<%=label%>" cols="30" rows="3"><%=value%></textarea>
  <%
}

else if ( FieldType.BOOLEAN.equals(type) )
{
  Boolean bValue = Boolean.valueOf((String) value);
  %>
  <input type="hidden" name="<%=label%>" value="false"/>
  <input type="checkbox" name="<%=label%>" <%if ( bValue ) out.println( "checked=\"true\"" );%>/>
  <%
}

else if ( FieldType.READONLYBOOLEAN.equals(type) )
{
  Boolean bValue = Boolean.valueOf((String) value);
  %>
  <input type="hidden" name="<%=label%>" value="<%=value%>"/>
  <input type="checkbox" disabled="disabled" name="<%=label%>" <%if ( bValue ) out.println( "checked=\"true\"" );%> />
  <%
}

else if ( FieldType.DISABLED.equals(type) )
{
  %>
  <input type="text" name="<%=label%>" value="<%=value%>" readonly="readonly"/>
  <%
}

// Static Lists
else if ( FieldType.LIST.equals(type) )
{
  %>
  <select name="<%=label%>">
  <%
  Map<String, String> list = staticListsHPNNMi.get( label );

  for (String key : list.keySet())
  {
    String listVal = list.get(key);
    %><option value="<%=listVal%>" <%if ( listVal.equals( value ) ) out.print( "selected=\"selected\"" );%>><%=key%></option><%

  }
  %>
  </select>
  <%
}

else if ( FieldType.TABLE.equals(type) )
{
    %>
    <a name="<%=label%>"/>
    <tr>
      <td colspan="2">
        <table class="no-border">
          <tr><th colspan="2"><%=label%></th></tr>
    <%
}

else if ( FieldType.SEARCH.equals(type) )
{

  %>
  <input type="text" name="<%=label%>" value="<%=value%>" readonly="readonly"/>
  <input type="submit" name="<%=field.getAssociatedJSP()%>" value="..."/>
  <%
}
%>